pub struct HandleData {
    pub id: u32,
    pub handle: String,
}

impl HandleData {
    pub fn new(id: u32, handle: String) -> HandleData {
        HandleData {
            id: id,
            handle: handle,
        }
    }
    pub fn serialize(&self) -> Vec<u8> {
        let mut serialized_data: Vec<u8> = Vec::new();
        serialized_data.extend(&self.id.to_be_bytes());
        let handle = crate::packet::types::string::String {
            content: self.handle.clone(),
        };
        serialized_data.extend(handle.serialize());
        serialized_data
    }
}
