use std::io::Read;

pub struct StatData {
    pub id: u32,
    pub path: String,
}

impl StatData {
    pub fn deserialize(mut data_to_serialize: &[u8]) -> StatData {
        let mut id: [u8; 4] = [0; 4];
        data_to_serialize.read(&mut id).expect("Failed to read id.");
        let id: u32 = u32::from_be_bytes(id);
        let path: String =
            crate::packet::types::string::String::deserialize(data_to_serialize).content;
        StatData { id: id, path: path }
    }
}
