pub struct StatusData {
    pub id: u32,
    pub status_code: u32,
    pub error_message: String,
    pub lang: String,
}
impl StatusData {
    pub fn serialize(&self) -> Vec<u8> {
        let mut serialized_data: Vec<u8> = Vec::new();
        serialized_data.extend(&self.id.to_be_bytes());
        serialized_data.extend(&self.status_code.to_be_bytes());
        let error_message = crate::packet::types::string::String {
            content: self.error_message.clone(),
        };
        let lang = crate::packet::types::string::String { content: self.lang.clone() };
        serialized_data.extend(error_message.serialize());
        serialized_data.extend(lang.serialize());
        serialized_data
    }
}
